#!python

from inspect import getfullargspec
from copy import  copy
from types import FunctionType


def cons(ls, x):
    ls1=copy(ls)
    ls1.append(x)
    return ls1


def curry(fun, av=[]):

    ac = len(getfullargspec(fun).args)
    assert isinstance(fun, FunctionType) and len(av) < ac
    
    def curried(x):
        av1=cons(av, x)
        return  fun(*av1) if len(av1) == ac  else curry(fun, av1)

    return curried



@curry
def add3(x,y,z):
    return x+y+z

@curry
def sub3(x,y,z):
    return x-y-z

if __name__=='__main__':

    print( \
"""
@curry
def add3(x,y,z):
    return x+y+z

@curry
def sub3(x,y,z):
    return x-y-z
""" \
)
    print ( 'add3(1)(2)(3) = ', add3(1)(2)(3) )
    p = sub3(10)(2)
    print ('p = sub3(10)(2)')
    print ( 'p(3)=', p(3) )
    print ( 'p(7)=', p(7) )



