#!python3.2

from inspect import getfullargspec
from copy import  copy
from types import FunctionType


def cons(ls, x):
    ls1=copy(ls)
    ls1.append(x)
    return ls1


class Curry :
    '''class of Curried function'''

    def __init__(self, fun, av=[]):
        self.fun = fun
        self.ac = len(getfullargspec(fun).args)
        self.av=av
        assert isinstance(self.fun, FunctionType) and len(self.av) < self.ac


    def __call__(self, val):
        av = cons(self.av, val)
        return self.fun(*av) if len(av) == self.ac else Curry(self.fun, av)


# Test code


@Curry
def add3(x,y,z):
    return x+y+z

@Curry
def sub3(x,y,z):
    return x-y-z

if __name__=='__main__':

    print( \
"""
@Curry
def add3(x,y,z):
    return x+y+z

@Curry
def sub3(x,y,z):
    return x-y-z""" \
)
    print ( 'add3(1)(2)(3) = ', add3(1)(2)(3) )
    p = sub3(10)(2)
    print ('p = sub3(10)(2)')
    print ( 'p(3)=', p(3) )
    print ( 'p(7)=', p(7) )



